/*

  FEA launches a DOS program associated to the filename extension
    Copyright (C) 2007  BAHCL  bahcl@hotmail.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    FEA is inspired by the FreeDOS START with some improvement
    Please read the NEWS file for all the changes and read FEA.MAN to learn
    how to use.
*/


#include <dir.h>
#include <process.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fea.h"


char *fea_ini = "FEA.INI";
char *fea_man = "FEA.MAN";
char *dft = "[DEFAULT]";
char *bare_name;
char *pgmptr;
char *pgminfo;
char *tmp;
char **_argv;

long addresses[MAXPGM];
long extaddr;
long dftaddr;

char psw;
char cmdline[128];
char filename[128];                        /* filename from commmand line */
char inipath[128];                         /* Full path for FEA.INI */
char buffer[_MAX_PATH];

char *usage = "\xD\xA\
FEA version 0.2, Copyright (C) 2007  BAHCL\xD\xA\
Designed and programmed by BAHCL, all rights reserved.\xD\xA\
FEA launches a DOS program related to the filename extension.\xD\xA\
FEA comes with ABSOLUTELY NO WARRANTY, use it at your own risk!\xD\xA\
This is free software, you are welcome to redistribute it under\xD\xA\
the terms of the GNU General Public License version 2.\xD\xA\xA\
Syntax:\xD\xA\x9\
FEA [/switch filename | /?]\xD\xA\
Where switch may be any of { 1..3 }\xD\xA\
Read manual FEA.MAN for details.\xD\xA";

extern unsigned _heaplen = 8192;

int main(int argc, char *argv[])
{
   int  i;
   int  max    = 0;
   int  error  = 0;
   long address;
   char *extension;
   char *filearray;
   char swtch;
   struct ffblk ffblk;
   FILE *fp;

   _argv = argv;
/* Clear array to store address of associated program */
   for (i = 0; i < MAXPGM; i++)
      addresses[i] = 0L;

   if (argc == 1)    /* no parameters */
   {
      write(1, usage, strlen(usage));
      exit(0);
   }

   if (argc > 2)    /* for swith=1,2,3 */
   {
      strcpy(filename, argv[2]);
      if (findfirst(filename, &ffblk, _A_NORMAL) != 0)
      {
         write(1, "err01", 5);
         exit(3);
      }
      /* find '.' then convert '.ext' into '[EXT]' */
      extension = strrchr(filename, '.');
      bare_name = strrchr(filename, '\\');
      strcpy(buffer+_MAX_PATH-6, extension);
      extension = buffer+_MAX_PATH-6;
      strupr(extension);
      buffer[_MAX_PATH-6] = '[';
      strcat(extension,"]");
      buffer[_MAX_PATH-1] = 0;

      /* Setup the path for FEA.INI */
      strcpy(inipath, argv[0]);
      tmp = strrchr(inipath, '\\');
      strcpy(tmp+1, fea_ini);

      /* find fea.ini from the path of fea.exe and %PATH% */
      if ((fp = fopen(inipath,"rt")) == NULL)
      {
         strcpy(inipath, searchpath(fea_ini));
         if ((fp = fopen(inipath, "rt")) == NULL)
         {
            write(1, "err02", 5);                  /* no .ini file */
            exit(2);
         }
      }

      address = Get_Associate_Pgm_Addr(extension, fp);
      if (address == 0)
      {
         address = Get_Associate_Pgm_Addr(dft, fp);
      }
      psw = Get_Pgm_Info(address, fp);
   }

   swtch = argv[1][1];
   switch(swtch)
   {
      case '1': /* load and run with the 1st associated program */
         if (address == 0)
         {
            write(1, "err03", 5);                  /* no program */
            error = 3;
            break;
         }
         append_args(argc);
         go_spawn(pgmptr);
         break;
      case '2': /* user select */
         append_args(argc);
         max = Get_More_Addr(address, fp);
         address = addresses[0];
         psw = Get_Pgm_Info(address, fp);
         if ((i = kbdhndlr(max, fp)) == 2)
         {
            go_spawn(cmdline);
         }
         break;
      case '3': /* use default program */
         append_args(argc);
         dftaddr = Get_Associate_Pgm_Addr(dft, fp);
         psw = Get_Pgm_Info(dftaddr, fp);
         go_spawn(pgmptr);
         break;
      case '?': /* help */
         write(1, usage, strlen(usage));
         break;
      default :
         write(1, "err04", 5);                  /* wrong switch */
         error = 4;
         break;
   }
   fclose(fp);
   return error;
}

void go_spawn(char *cmdstr)
{
int   i;
   cmdstr = Check_Program(cmdstr);
   i = strlen(cmdline);
   cmdline[i+1] = 0;
   cmdline[i] = CR;
   switch(psw)
   {
      case '0' :
         spawnlp(P_WAIT, cmdline, cmdline, filename, NULL);
         break;
      case '1' :    /* change path to filename  */
         cmdline[i] = '\x20';
         bare_name[0] = 0;
         i = getdisk();
         getcurdir(0,buffer+3);
         buffer[0]=i+'A';
         buffer[1]=':';
         buffer[2]='\\';
         setdisk(filename[0]-'A');
         chdir(filename);
         strcat(cmdline, bare_name+1);
         strcat(cmdline, "\xD\xA");
         system(cmdline);
         chdir(buffer);
         setdisk(buffer[0]-'A');
         break;
      case '2' :
         cmdline[i] = '\x20';
         strcat(cmdline, filename);
         tmp = strchr(pgminfo,';');
         strcpy(tmp,"\xD\xA");
         strcat(cmdline, pgminfo);
         system(cmdline);
         break;
      case '3' :
         cmdline[i] = '\x20';
         tmp = strchr(pgminfo,',');
         *tmp = '\x0';
         strcat(cmdline, pgminfo);
         strcat(cmdline, " ");
         strcat(cmdline, filename);
         strcat(cmdline, " ");
         strcat(cmdline, tmp+1);
         tmp = strchr(cmdline,';');
         strcpy(tmp,"\xD\xA");
         iaca();
         clean(cmdline);
         system(cmdline);
         break;
      case '4' :
         strcpy(cmdline+1, filename);
         strcat(cmdline,"\xD");
         i = strlen(cmdline);
         cmdline[0] = (char) i;
         system(cmdline);
         break;
   }
}

/* append other args... to filename */
void append_args(int arg_c)
{
int   argidx = 3;
   while (argidx < arg_c)
   {
      strcat(filename, BLANK);
      strcat(filename, _argv[argidx++]);
   }
}

/* find the address of first associate program */
long Get_Associate_Pgm_Addr(char *ext, FILE *fhandle)
{
   int i;

   fseek(fhandle, 0L, SEEK_SET);
   i = strlen(ext);
   while(fgets(buffer, _MAX_PATH-1, fhandle) != NULL)
   {
      strupr(buffer);
      if ((strncmp(buffer, ext, i)) == 0)
         return ftell(fhandle);
   }
   return 0L;  /* 0 = failure */
}

/* find and fill up array of address from associated programs */
int Get_More_Addr(long address, FILE *fhandle)
{
   int i = 0;

   fseek(fhandle, address, SEEK_SET);
   do
   {
      addresses[i] = address;
      fgets(buffer, _MAX_PATH-1, fhandle);
      if (buffer[0] <= '\x20')
         return i;
      if (buffer[0] == '#')
         return i;
      i++;
      address = ftell(fhandle);
   } while (i < MAXPGM);
   return i;    /* i = the number of associated programs under extension */
}

/* Check if a program exist, append .EXE and .COM if absent */
char *Check_Program(char *program)
{
   if (strrchr(program, '.') == NULL)     /* append program with .EXE or .COM */
   {
      strcat(program, ".EXE");
      if (searchpath(program) == NULL)
      {
         tmp = strstr(program, ".EXE");
         strcpy(tmp,".COM");
         if ((searchpath(program)) == NULL)
         {
            strcpy(program,"");
         }
      }
   }
   else
      tmp = searchpath(program);

   return tmp;
}

/* get program information defined in fea.ini */
char Get_Pgm_Info(long address, FILE *fhandle)
{
   fseek(fhandle, address, SEEK_SET);
   fgets(cmdline, _MAX_PATH-1, fhandle);
   tmp = strchr(cmdline,',');
   strcpy(buffer, tmp+1);
   tmp[0] = NULL;
   pgmptr = cmdline;
   pgminfo = buffer+2;
   return buffer[0];
}

/* Set up assembly routine to read keyboard */
int kbdhndlr(int m, FILE *fp)
{
   int quit = 0;
   int indx = 0;
   int i;

   write(1, "\xD\xATab=Other Programs, Enter=Okay, Esc=Exit\xD\xA", 44);
   do
   {
      Check_Program(cmdline);
      i = strlen(cmdline);
      if (i > 0)
      {
        write(1, cmdline, i);
        write(1, " ", 1);
      }
      write(1, filename, strlen(filename));
      write(1, "\xD\xA", 2);
      write(1, pgminfo, strlen(pgminfo));
      write(1, "\xD\xA", 2);
      i = kbget();
      switch(i)
        {
          case ESC:
            quit = 1;
            break;
          case RETURN:
            quit = 2;
            break;
          case SPACEBAR:
            ++indx;
            break;
         }
       if (indx == m) indx = 0;              /* select new program */
       psw = Get_Pgm_Info(addresses[indx], fp);
   } while (quit == 0);

   return quit;
}
